## org.apache.commons.math.distribution
Class NormalDistributionImpl

    java.lang.Object
      org.apache.commons.math.distribution.AbstractDistribution
          org.apache.commons.math.distribution.AbstractContinuousDistribution
              org.apache.commons.math.distribution.NormalDistributionImpl

All Implemented Interfaces:
  java.io.Serializable, ContinuousDistribution, Distribution, HasDensity<java.lang.Double>, NormalDistribution

    public class NormalDistributionImpl

extends AbstractContinuousDistribution
implements NormalDistribution, java.io.Serializable

Default implementation of `NormalDistribution`.

Version:
  $Revision: 772119 $ $Date: 2009-05-06 05:43:28 -0400 (Wed, 06 May 2009) $
See Also:
  Serialized Form

Field Summary
`private double` `mean` The mean of this distribution.
`private static long` `serialVersionUID` Serializable version identifier
`private static double` `SQRT2PI` &sqrt;(2 π)
`private double` `standardDeviation` The standard deviation of this distribution.

Constructor Summary
`NormalDistributionImpl()` Creates normal distribution with the mean equal to zero and standard deviation equal to one.
`NormalDistributionImpl(double mean, double sd)` Create a normal distribution using the given mean and standard deviation.

Method Summary
`double` `cumulativeProbability(double x)` For this distribution, X, this method returns P(X < `x`).
`double` `density(java.lang.Double x)` Return the probability density for a particular point.
`protected double` `getDomainLowerBound(double p)` Access the domain value lower bound, based on `p`, used to bracket a CDF root.
`protected double` `getDomainUpperBound(double p)` Access the domain value upper bound, based on `p`, used to bracket a CDF root.
`protected double` `getInitialDomain(double p)` Access the initial domain value, based on `p`, used to bracket a CDF root.
`double` `getMean()` Access the mean.
`double` `getStandardDeviation()` Access the standard deviation.
`double` `inverseCumulativeProbability(double p)` For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.
`void` `setMean(double mean)` Modify the mean.
`void` `setStandardDeviation(double sd)` Modify the standard deviation.

Methods inherited from class org.apache.commons.math.distribution.AbstractDistribution
`cumulativeProbability`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.commons.math.distribution.Distribution
`cumulativeProbability`

Field Detail

### serialVersionUID

    private static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### SQRT2PI

    private static final double SQRT2PI

  &sqrt;(2 π)

### mean

    private double mean

  The mean of this distribution.

### standardDeviation

    private double standardDeviation

  The standard deviation of this distribution.

Constructor Detail

### NormalDistributionImpl

    public NormalDistributionImpl(double mean,
                                  double sd)

  Create a normal distribution using the given mean and standard deviation.

  Parameters:
    `mean` - mean for this distribution
    `sd` - standard deviation for this distribution

### NormalDistributionImpl

    public NormalDistributionImpl()

  Creates normal distribution with the mean equal to zero and standard deviation equal to one.

Method Detail

### getMean

    public double getMean()

  Access the mean.

  Specified by:
    `getMean` in interface `NormalDistribution`
  Returns:
    mean for this distribution

### setMean

    public void setMean(double mean)

  Modify the mean.

  Specified by:
    `setMean` in interface `NormalDistribution`
  Parameters:
    `mean` - for this distribution

### getStandardDeviation

    public double getStandardDeviation()

  Access the standard deviation.

  Specified by:
    `getStandardDeviation` in interface `NormalDistribution`
  Returns:
    standard deviation for this distribution

### setStandardDeviation

    public void setStandardDeviation(double sd)

  Modify the standard deviation.

  Specified by:
    `setStandardDeviation` in interface `NormalDistribution`
  Parameters:
    `sd` - standard deviation for this distribution
  Throws:
    `java.lang.IllegalArgumentException` - if `sd` is not positive.

### density

    public double density(java.lang.Double x)

  Return the probability density for a particular point.

  Specified by:
    `density` in interface `HasDensity<java.lang.Double>`
  Specified by:
    `density` in interface `NormalDistribution`
  Parameters:
    `x` - The point at which the density should be computed.
  Returns:
    The pdf at point x.

### cumulativeProbability

    public double cumulativeProbability(double x)
                                 throws MathException

  For this distribution, X, this method returns P(X < `x`).

  Specified by:
    `cumulativeProbability` in interface `Distribution`
  Parameters:
    `x` - the value at which the CDF is evaluated.
  Returns:
    CDF evaluted at `x`.
  Throws:
    `MathException` - if the algorithm fails to converge; unless x is more than 20 standard deviations from the mean, in which case the convergence exception is caught and 0 or 1 is returned.

### inverseCumulativeProbability

    public double inverseCumulativeProbability(double p)
                                        throws MathException

  For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.

  Returns `Double.NEGATIVE_INFINITY` for p=0 and `Double.POSITIVE_INFINITY` for p=1.

  Specified by:
    `inverseCumulativeProbability` in interface `ContinuousDistribution`
  Overrides:
    `inverseCumulativeProbability` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability
  Returns:
    x, such that P(X < x) = `p`
  Throws:
    `MathException` - if the inverse cumulative probability can not be computed due to convergence or other numerical errors.
    `java.lang.IllegalArgumentException` - if `p` is not a valid probability.

### getDomainLowerBound

    protected double getDomainLowerBound(double p)

  Access the domain value lower bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainLowerBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value lower bound, i.e. P(X < lower bound) < `p`

### getDomainUpperBound

    protected double getDomainUpperBound(double p)

  Access the domain value upper bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainUpperBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value upper bound, i.e. P(X < upper bound) > `p`

### getInitialDomain

    protected double getInitialDomain(double p)

  Access the initial domain value, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getInitialDomain` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    initial domain value

Copyright (c) 2003-2010 Apache Software Foundation